FLTK 1.4.4: Fl_GIF_Image Class Reference

FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_GIF_Image Class Reference

The Fl_GIF_Image class supports loading, caching, and drawing of Compuserve GIFSM images. More...

`#include <Fl_GIF_Image.H>`

Inheritance diagram for Fl_GIF_Image:

## Classes
struct | GIF_FRAME

## Public Member Functions
| Fl_GIF_Image (const char *filename)
| This constructor loads a GIF image from the given file.
| Fl_GIF_Image (const char *imagename, const unsigned char *data)
| This constructor loads a GIF image from memory (deprecated).
| Fl_GIF_Image (const char *imagename, const unsigned char *data, const size_t length)
| This constructor loads a GIF image from memory.
Public Member Functions inherited from Fl_Pixmap
int | cache_h ()
int | cache_w ()
void | color_average (Fl_Color c, float i) FL_OVERRIDE
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
Fl_Image * | copy (int W, int H) const FL_OVERRIDE
| Creates a resized copy of the image.
void | desaturate () FL_OVERRIDE
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
void | draw (int X, int Y, int W, int H, int cx=0, int cy=0) FL_OVERRIDE
| Draws the image to the current drawing surface with a bounding box.
| Fl_Pixmap (char *const *D)
| The constructors create a new pixmap from the specified XPM data.
| Fl_Pixmap (const char *const *D)
| The constructors create a new pixmap from the specified XPM data.
| Fl_Pixmap (const uchar *const *D)
| The constructors create a new pixmap from the specified XPM data.
| Fl_Pixmap (uchar *const *D)
| The constructors create a new pixmap from the specified XPM data.
void | label (Fl_Menu_Item *m) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a menu item.
void | label (Fl_Widget *w) FL_OVERRIDE
| This method is an obsolete way to set the image attribute of a widget or menu item.
void | uncache () FL_OVERRIDE
| If the image has been cached for display, delete the cache data.
virtual | ~Fl_Pixmap ()
| The destructor frees all memory and server resources that are used by the pixmap.
Public Member Functions inherited from Fl_Image
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Static Public Member Functions
static bool | is_animated (const char *name_)
Static Public Member Functions inherited from Fl_Image
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.

## Static Public Attributes
static bool | animate = false
| Sets how the shared image core routine should treat animated GIF files.
Static Public Attributes inherited from Fl_Image
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.

## Protected Member Functions
| Fl_GIF_Image ()
| The default constructor creates an empty GIF image.
| Fl_GIF_Image (const char *filename, bool anim)
| Fl_GIF_Image (const char *imagename, const unsigned char *data, const size_t length, bool anim)
void | load (const char *filename, bool anim)
| The protected load() methods are used by Fl_Anim_GIF_Image to request loading of animated GIF's.
void | load (const char *imagename, const unsigned char *data, const size_t length, bool anim)
void | load_gif_ (class Fl_Image_Reader &rdr, bool anim=false)
virtual void | on_extension_data (GIF_FRAME &)
virtual void | on_frame_data (GIF_FRAME &)
Protected Member Functions inherited from Fl_Pixmap
void | measure ()
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.

## Additional Inherited Members
Public Attributes inherited from Fl_Pixmap
int | alloc_data
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_GIF_Image class supports loading, caching, and drawing of Compuserve GIFSM images.

The class loads the first image and supports transparency.

## Constructor & Destructor Documentation

## ◆ Fl_GIF_Image() [1/3]

Fl_GIF_Image::Fl_GIF_Image | ( | const char * | filename | ) |

This constructor loads a GIF image from the given file.

If a GIF image is animated, Fl_GIF_Image will only read and display the first frame of the animation.

The destructor frees all memory and server resources that are used by the image.

Use Fl_Image::fail() to check if Fl_GIF_Image failed to load. fail() returns ERR_FILE_ACCESS if the file could not be opened or read, ERR_FORMAT if the GIF format could not be decoded, and ERR_NO_IMAGE if the image could not be loaded for another reason.

Parameters

  [in] | filename | a full path and name pointing to a GIF image file.

See also
  Fl_GIF_Image::Fl_GIF_Image(const char *imagename, const unsigned char *data, const long length)

## ◆ Fl_GIF_Image() [2/3]

Fl_GIF_Image::Fl_GIF_Image | ( | const char * | imagename,
|  | const unsigned char * | data )

This constructor loads a GIF image from memory (deprecated).

Deprecated
  Please use Fl_GIF_Image(const char *imagename, const unsigned char *data, const size_t length) instead.

Note
  Buffer overruns will not be checked.

This constructor should not be used because the caller can't supply the memory size and the image reader can't check for "end of memory" errors.

Note
  A new constructor with parameter `length` is available since FLTK 1.4.0.

Parameters

  [in] | imagename | A name given to this image or NULL
  [in] | data | Pointer to the start of the GIF image in memory.

See also
  Fl_GIF_Image(const char *filename)
  Fl_GIF_Image(const char *imagename, const unsigned char *data, const size_t length)

## ◆ Fl_GIF_Image() [3/3]

Fl_GIF_Image::Fl_GIF_Image | ( | const char * | imagename,
|  | const unsigned char * | data,
|  | const size_t | length )

This constructor loads a GIF image from memory.

Construct an image from a block of memory inside the application. Fluid offers "binary data" chunks as a great way to add image data into the C++ source code. `imagename` can be `NULL`. If a name is given, the image is added to the list of shared images and will be available by that name.

If a GIF image is animated, Fl_GIF_Image will only read and display the first frame of the animation.

The destructor frees all memory and server resources that are used by the image.

The third parameter `length` is used to test for buffer overruns, i.e. truncated images.

Use Fl_Image::fail() to check if Fl_GIF_Image failed to load. fail() returns ERR_FILE_ACCESS if the file could not be opened or read, ERR_FORMAT if the GIF format could not be decoded, and ERR_NO_IMAGE if the image could not be loaded for another reason.

Parameters

  [in] | imagename | A name given to this image or NULL
  [in] | data | Pointer to the start of the GIF image in memory.
  [in] | length | Length of the GIF image in memory.

See also
  Fl_GIF_Image::Fl_GIF_Image(const char *filename)
  Fl_Shared_Image

Since
  1.4.0

## Member Data Documentation

## ◆ animate

bool Fl_GIF_Image::animate = false
| static

Sets how the shared image core routine should treat animated GIF files.

The default is to treat them as ordinary GIF's e.g. it creates a Fl_GIF_Image object. If this variable is set, then an animated GIF object Fl_Anim_GIF_Image is created.

The documentation for this class was generated from the following files:

- Fl_GIF_Image.H
- Fl_Anim_GIF_Image.cxx
- Fl_GIF_Image.cxx